// management of serial data, cpu-bound, mockup

#ifndef __XATREMU_SERIAL_REAL__
#define __XATREMU_SERIAL_REAL__

#include "serial_base.h"

namespace xatremu
{
class SerialReal : public SerialBase
{
public:
	SerialReal();
	virtual ~SerialReal();
	virtual void ResetSerial();
	virtual void SetIntLineAtari(bool intLine);
	virtual bool StateIntLine();
	virtual bool StateT0Line();
	virtual void T0NextBit();
	virtual void SerialOutBit(bool outBit);
	virtual void P17NextBit();
	virtual bool ReadyForNextInByte();
	virtual void SerialByteFromAtari(unsigned char A800Byte);
	virtual bool SerialOutByteComplete();
	virtual unsigned char SerialByteToAtari();
	virtual void SetSIOSpeed(unsigned char Speed);

protected:

private:
	friend class testCPU8040;
};
}
#endif
